/* TCP knocking
 * 
 * Ports that appear closed for normal packets but open only
 * to packets with passwords.
 *
 * (C) 2005 Ganesh <ganhawk@yahoo.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation.
 */

#include <linux/config.h>
#include <linux/module.h>
#include <linux/version.h>
#include <linux/netfilter_ipv4.h>
#include <linux/skbuff.h>
#include <linux/inet.h>
#include <linux/netdevice.h>
#include <net/protocol.h>
#include <net/tcp.h>
#include <net/ip.h>
#include <net/checksum.h>
#include <linux/netfilter_ipv4/ip_tables.h>

/*    
   Thanks to analysis and public domain code by
   Robert J. Jenkins Jr.
   Parts of his code are used by Hash and Mixer
*/

#define mix(a,b,c) \
{ \
  a=a-b;  a=a-c;  a=a^(c>>13); \
  b=b-c;  b=b-a;  b=b^(a<<8);  \
  c=c-a;  c=c-b;  c=c^(b>>13); \
  a=a-b;  a=a-c;  a=a^(c>>12); \
  b=b-c;  b=b-a;  b=b^(a<<16); \
  c=c-a;  c=c-b;  c=c^(b>>5);  \
  a=a-b;  a=a-c;  a=a^(c>>3);  \
  b=b-c;  b=b-a;  b=b^(a<<10); \
  c=c-a;  c=c-b;  c=c^(b>>15); \
}

#define KEY_SIZE 65536


__u32 hash_key_bytes(__u16 k);

int load_key_stream(void);
#ifdef DEBUG
void print_packet(struct sk_buff *skb);
#endif



