/*
gen_key_file.c
(c) 2005 Ganesh <ganhawk@yahoo.com>
GNU GPL

This program generates the 64KB key required for the port protector 
and writes to a file called port_protector.dat.  
It is recomended you save the file as /etc/port_protector.dat

This may take some time. Please continue working on your 
keyboard as /dev/random uses keystroke timings to generate random numbers.
*/


#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>

int  main()
{
   int fd, wfd, ret;
   char buf[65536];

   if((fd = open("/dev/urandom",O_RDONLY)) <0) {
      fprintf(stderr,"/dev/random does not seem to be present. Generate the key using some other method");
      exit(-1);
   }

   ret = 0;
   while(ret < sizeof(buf)) {
      ret += read(fd,buf+ret,sizeof(buf)-ret);
      if(ret == sizeof(buf)-1) { 
         break;
      }
   }
   
   if(ret != sizeof(buf) ) {
      fprintf(stderr,"\n Read Failed !! %d",ret);
      exit(-1);
   }

   if((wfd = open("port_protector.dat",O_RDWR|O_CREAT)) <0){
      fprintf(stderr,"Cannot open file for writing");
      exit(-1);
   }

   ret = write(wfd,buf,sizeof(buf));

   if(ret != sizeof(buf) ){
     fprintf(stderr,"\n Failed !! %d",ret);
     exit(-1);
   }

   return 0;
}
